From d43cba875b5b777f2663d5bf4199b21076053d68 Mon Sep 17 00:00:00 2001
From: hanishkvc <hanishkvc@gmail.com>
Date: Thu, 5 May 2022 03:53:30 +0530
Subject: [PATCH 4/5] Resolv: Trap post increament bug possibility, change to
 pre incr

Purposefully changed to /dev/urandom1 to verify the possible issue
with post increment of local_id passed to dnsrand_next. As had
thought, the local_id wont increment in this case, bcas urandom
fails and fallsback to passed default_value which is the local_id
before increment, so dns query id will be stuck at 1 or what ever
the initially set value.

My C memory has become bit rustic ;), even thou the doubt was there
in the background.

This is fixed by changing to pre increment before passing as defVal
to dnsrand_next.
---
 libc/inet/resolv.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/libc/inet/resolv.c b/libc/inet/resolv.c
index 7d952af28..8cd3ad502 100644
--- a/libc/inet/resolv.c
+++ b/libc/inet/resolv.c
@@ -1181,7 +1181,7 @@ int __dns_lookup(const char *name,
 		}
 		if (local_ns_num >= __nameservers)
 			local_ns_num = 0;
-		local_id = dnsrand_next(urand_fd, local_id++);
+		local_id = dnsrand_next(urand_fd, ++local_id);
 		local_id &= 0xffff;
 		/* write new values back while still under lock */
 		last_id = local_id;
-- 
2.20.1

